# 《Spring5核心原理与30个类手写实战》
### 4个月销量破万，连续占据畅销榜

### 京东购买链接：[https://item.jd.com/12650902.html](https://item.jd.com/12650902.html?_blank)

### 当当购买链接：[http://product.dangdang.com/27905338.html](http://product.dangdang.com/27905338.html)

倾注十年Spring研究精华与见解

★本书几乎涵盖在Spring应用中可能遇到的所有问题，核心原理（IoC、DI、AOP、MVC）、高仿手写、数据访问等

★深度解析Spring 5的原理与新特性，从环境准备、顶层结构设计、数据访问等方面一步步推导出Spring设计原理

★通过本书你可以：

--看源码不再晕车，轻松找到入口。

--系统学习设计思想，提高解决问题的效率。

--培养架构思维能力，自驱学习能力。

--用30个类提炼出Spring核心的精华思想，并保证功能可用。

--从不一样的角度分析Spring经典高频面试题。

--了解Spring 5 的新特性。

--为深入了解Spring Boot做铺垫。

# 关于我

### 为什么说我来自文艺界？
　　我自幼爱好书法和美术，长了一双能书会画的手，而且手指又长又白，因此以前的艺名叫“玉手藝人”。中学期间，曾获市级书法竞赛一等奖，校园美术竞赛一等奖，校园征文比赛二等奖。担任过学生会宣传部长，负责校园黑板报、校园刊物的编辑、排版、设计。
　　2008年参加工作后，做过家具建模、平面设计等工作，亲自设计了咕泡学院的Logo。做讲师之后，给自己起了一个跟姓氏谐音的英文名字“Tom”，江湖人称“编程界写字写得最好的、书法界编程最牛的文艺汤”。
### 我的技术生涯
　　我的IT技术生涯应该算是从2009年开始的，在此之前做过UI设计，做过前端网页，到2009年才真正开始参与Java后台开发。在这里要感谢所有帮助过我入门编程的同事和老师。从2010年至2014年担任过项目组长、项目经理、架构师、技术总监，对很多的开源框架建立了自己的独特见解。我会习惯性地用形象思维来理解抽象世界。譬如：看到二进制0和1，我会想到《周易》中的两仪——阴和阳；看到颜色值用RGB表示，我会想到美术理论中的太阳光折射三原色；下班回家看到炒菜流程，我会想到模板方法模式；坐公交车看到学生卡、老人卡、爱心卡，我会想到策略模式；等等。大家看到的这本书，很多地方都融入了这种形象思维。
### 为什么写书？
　　其实一开始我没想过要写书，写书的初衷主要是满足学员的诉求。大家认为我个人的学习方法、思维模式、教学方式通俗易懂，很容易让人接受，但是通过视频形式传播受众有限，学员建议我把这些宝贵的经验以纸质书的形式奉献给大家，这样定会给社会带来更大的价值。
　　借此机会，特别感谢责任编辑董英及电子社的团队成员为本书审稿纠错；感谢我老婆在无数个加班的夜晚给我默默的支持；感谢咕泡学院的学员给本书内容提出宝贵的修改意见。
 
# 随书资源下载

1. [一步一步手绘Spring DI运行时序图.jpg](https://github.com/gupaoedu-tom/resouce/blob/master/spring5/%E4%B8%80%E6%AD%A5%E4%B8%80%E6%AD%A5%E6%89%8B%E7%BB%98Spring%20DI%E8%BF%90%E8%A1%8C%E6%97%B6%E5%BA%8F%E5%9B%BE.jpg)
2. [一步一步手绘Spring IOC运行时序图.jpg](https://github.com/gupaoedu-tom/resouce/blob/master/spring5/%E4%B8%80%E6%AD%A5%E4%B8%80%E6%AD%A5%E6%89%8B%E7%BB%98Spring%20IOC%E8%BF%90%E8%A1%8C%E6%97%B6%E5%BA%8F%E5%9B%BE.jpg)
3. [一步一步手绘Spring AOP运行时序图.jpg](https://github.com/gupaoedu-tom/resouce/blob/master/spring5/%E4%B8%80%E6%AD%A5%E4%B8%80%E6%AD%A5%E6%89%8B%E7%BB%98Spring%20AOP%E8%BF%90%E8%A1%8C%E6%97%B6%E5%BA%8F%E5%9B%BE.jpg)
4. [一步一步手绘Spring MVC运行时序图.jpg](https://github.com/gupaoedu-tom/resouce/blob/master/spring5/%E4%B8%80%E6%AD%A5%E4%B8%80%E6%AD%A5%E6%89%8B%E7%BB%98Spring%20MVC%E8%BF%90%E8%A1%8C%E6%97%B6%E5%BA%8F%E5%9B%BE.jpg)
5. [SpringMVC核心组件关系图.png](https://github.com/gupaoedu-tom/resouce/blob/master/spring5/SpringMVC%E6%A0%B8%E5%BF%83%E7%BB%84%E4%BB%B6%E5%85%B3%E7%B3%BB%E5%9B%BE.png)
6. [SpringJDBC异常结构图.png](https://github.com/gupaoedu-tom/resouce/blob/master/spring5/SpringJDBC%E5%BC%82%E5%B8%B8%E7%BB%93%E6%9E%84%E5%9B%BE.png)
  
  
# 技术交流
![image](https://github.com/gupaoedu-tom/resouce/blob/master/gupaoedu-tom-qrcode.png)

### 推荐[《Netty 4核心原理与手写RPC框架》](https://github.com/gupaoedu-tom/netty4-samples)即将开启预售...
### 下一本《重学设计模式：从框架源码理解设计模式》正在撰稿中，请关注...

